# deck-gitea-integration
This NodeJS app automatically creates nextcloud [Deck](https://apps.nextcloud.com/apps/deck) cards based on [gitea](https://gitea.io/en-us/) issues.

May one day be published as a nextcloud/gitea plugin. Right now it's just for internal use. It's stable in my environment, but claims no guarantees to yours.

## Overview
You'll need to set-up a gitea webhook for each repository you want to auto-add to deck. The webhook must point to the address where this node app is running.

The webhook requests that are now being sent to NodeJS will be parsed and published on Deck. In order to do so you'll need to provide
- A Nextcloud isntallation (URL, not the api)
- A Nextcloud username+password (or username+appPassword) that has access to your Deck board
- A Nextcloud Deck board (numeric ID)
- The deck stack(column) where you want your cards to appear when first created (numeric ID).
- Gitea API url
- Gitea API key, owned by a dedicated 'Deck' or 'Deckbot' user or something (Don't use your own username!). User must have colaboration access to the repo.

After that, a 'Deck' label will be added to your gitea repo, and a 'Gitea' label to your deck board.

When you add the 'Deck' label to an issue, the NodeJS app will automatically pick-up on it, and add the issue to deck. It will also post a notification in the issue that a Deck card has been created.

When the 'Deck' label is removed from an issue, the Deck card is destroyed.
When you close an issue, the Deck card is archived.

When you remove a Deck card that's being tracked, the card will be re-added as soon as a webhook has been fired (AKA an action like commenting)
## Under the hood
WIP





## Deploy your own

WIP